package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.LogicCodeBlockGuiMenu;
import net.mcreator.puzzle_code.procedures.LogicCodeBlockDisplayOffProcedure;
import net.mcreator.puzzle_code.network.LogicCodeBlockGuiButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class LogicCodeBlockGuiScreen extends AbstractContainerScreen<LogicCodeBlockGuiMenu> {
	private final static HashMap<String, Object> guistate = LogicCodeBlockGuiMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_on_button;
	ImageButton imagebutton_off_button;
	ImageButton imagebutton_question_mark_button;

	public LogicCodeBlockGuiScreen(LogicCodeBlockGuiMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 80;
		this.imageHeight = 42;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/logic_code_block_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 53 && mouseX < leftPos + 73 && mouseY > topPos + 8 && mouseY < topPos + 28)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.logic_code_block_gui.tooltip_nbt_logiccodeblock"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
	}

	@Override
	public void init() {
		super.init();
		imagebutton_on_button = new ImageButton(this.leftPos + 8, this.topPos + 8, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new LogicCodeBlockGuiButtonMessage(0, x, y, z));
						LogicCodeBlockGuiButtonMessage.handleButtonAction(entity, 0, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button", imagebutton_on_button);
		this.addRenderableWidget(imagebutton_on_button);
		imagebutton_off_button = new ImageButton(this.leftPos + 8, this.topPos + 8, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (LogicCodeBlockDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button", imagebutton_off_button);
		this.addRenderableWidget(imagebutton_off_button);
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 53, this.topPos + 8, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
	}
}
